// TRAINMOD DATABLOCKS //

datablock PlayerData(MCartArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./models/furlingcart.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 60;
   maxBackwardSpeed = 60;
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 1;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 17 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 2.4", 4);
   crouchBoundingBox	= vectorScale("2.5 2.5 2.4", 4);
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= HorseJumpSound;

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Train - Motorized Minecart";
	rideable = true;
		lookUpLimit = 10;
		lookDownLimit = 10;

	canRide = false;
	showEnergyBar = false;
	paintable = true;
    
    numMountPoints = 1;
    mountThread[0] = "root";
    mountNode[0] = 2;
};

datablock PlayerData(BTrainArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./models/subway.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 60;
   maxBackwardSpeed = 60;
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 1;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 17 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= HorseJumpSound;

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Train - Box Train";
	rideable = true;
		lookUpLimit = 10;
		lookDownLimit = 10;

	canRide = false;
	showEnergyBar = false;
	paintable = true;
    
    numMountPoints = 5;
    mountThread[0] = "root";
    mountThread[1] = "root";
    mountThread[2] = "root";
    mountThread[3] = "root";
    mountThread[4] = "root";
    
    boundingBox			= vectorScale("3 3 3.5", 4);
    crouchBoundingBox	= vectorScale("3 3 3.5", 4);
};


datablock PlayerData(CartArmor : MCartArmor)
{
	uiName = "Train - Minecart";
};

datablock PlayerData(HorseGTArmor : HorseArmor)
{
	uiName = "Train - Horse GT";
};

datablock fxDtsBrickData(brickTrainGuideS)
{
	brickFile = "./bricks/track.blb";
	category = "Trains";
	subCategory = "Standard";
	uiName = "Track Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/track";
	hasPrint = 0;
};

datablock fxDtsBrickData(brickTrainGuideB)
{
	brickFile = "./bricks/boost.blb";
	category = "Trains";
	subCategory = "Standard";
	uiName = "Booster Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/boost";
	hasPrint = 0;
};

datablock fxDtsBrickData(brickTrainGuideSS : brick1x1fData)
{
	uiName = "Filler Guide";
	category = "Trains";
	subCategory = "Standard";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideCL : brick2x4fData)
{
	uiName = "Left Turn Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideCR : brick2x4fData)
{
	uiName = "Right Turn Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideTL : brick4x4fData)
{
	uiName = "Sharp Left Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideTR : brick4x4fData)
{
	uiName = "Sharp Right Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideWL : brick1x4fData)
{
	uiName = "Wide Left Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideWR : brick1x4fData)
{
	uiName = "Wide Right Guide";
	category = "Trains";
	subCategory = "Corners";
	indestructable = 1;
};

datablock fxDtsBrickData(brickTrainGuideI)
{
	brickFile = "./bricks/circle.blb";
	category = "Trains";
	subCategory = "Special";
	uiName = "Intersection Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/circle";
	hasPrint = 0;
};

datablock fxDtsBrickData(brickTrainGuideL)
{
	brickFile = "./bricks/circle.blb";
	category = "Trains";
	subCategory = "Special";
	uiName = "Launcher Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/circle";
	hasPrint = 0;
};

datablock fxDtsBrickData(brickTrainGuideTUR)
{
	brickFile = "./bricks/circle.blb";
	category = "Trains";
	subCategory = "Special";
	uiName = "Turntable Right Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/circle";
	hasPrint = 0;
};

datablock fxDtsBrickData(brickTrainGuideTUL)
{
	brickFile = "./bricks/circle.blb";
	category = "Trains";
	subCategory = "Special";
	uiName = "Turntable Left Guide";
	iconName = "Add-Ons/Support_TrainsAlpha/bricks/circle";
	hasPrint = 0;
};

// sound
// Minecart (Motorized)
datablock AudioProfile(TrainLaunchSound)
{
	filename = "./sound/clank1.wav";
	description = AudioClosest3d;
	preload = false;
};

datablock AudioProfile(TrainAlignSound)
{
	filename = "./sound/clank2.wav";
	description = AudioClosest3d;
	preload = false;
};

datablock AudioProfile(TrainCartRevSound)
{
	filename = "./sound/tempcartrev.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(TrainCartStartSound)
{
	filename = "./sound/tempcartstart.wav";
	description = AudioClose3d;
	preload = false;
};

// Box Train
datablock AudioProfile(TrainBoxRevSound)
{
	filename = "./sound/cruise4.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(TrainBoxIdleSound)
{
	filename = "./sound/idle.wav";
	description = AudioClose3d;
	preload = false;
};

// Any train
datablock AudioProfile(TrainBrakeSound)
{
	filename = "./sound/squeal.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(TrainBellSound)
{
	filename = "./sound/horn/bell.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(TrainHornSound)
{
	filename = "./sound/horn/horn_mid.wav";
	description = AudioClose3d;
	preload = false;
};