// TRAINMOD FUNCTIONS //

// brickrots
// 0 0 -1 90.0002 - west #
// 0 0 1 180 - south #
// 0 0 1 90.0002 - east #
// 1 0 0 0 - north #

function AIPlayer::AutoAlignDelay(%this) {
    %this.canalign = 1;
}

function AIPlayer::TrainTTDelay(%this) {
    %this.cantt = 1;
}

function AIPlayer::TrainLaunchDelay(%this) {
    %this.allowofftrack = 0;
    %this.canlaunch = 1;
}

function AIPlayer::TrainLoop(%this) {
    // sound checks (0 = stop with stopsound | 1 = start with startsound | 2 = instastart without sound | -1 = instastop without sound/idle sound)
    if(%this.playenginesound == 0) {
        if(%this.enginestopdata !$= 0) {
            if(%this.speed > %this.enginemax/2) {
                if($Pref::Trains::Sound == 1) {
                    serverPlay3D(%this.enginestopdata,%this.getPosition());
                }
            }
            //echo("Played stop sound!");
            %this.playenginesound = -1;
        }
    }
    if(%this.playenginesound == 1) {
        if(%this.enginestartdata !$= 0 || %this.enginerundata !$= 0) {
            if($Pref::Trains::Sound == 1) {
                serverPlay3D(%this.enginestartdata,%this.getPosition());
            }
            //echo("Played start sound!");
            %this.playenginesound = 2;
            %this.enginetick = -1; // start looping the engine sound
        }
    }
    else if(%this.playenginesound == 2) {
        if($Pref::Trains::Sound == 1) {
            serverPlay3D(%this.enginerundata,%this.getPosition());
        }
    }
    if(%this.playenginesound == -1) {
        if($Pref::Trains::Sound == 1) {
            serverPlay3D(%this.engineidledata,%this.getPosition());
        }
    }
    
    // now we need to check we're on a track
    initContainerBoxSearch(%this.getposition(), "1 1 4", $TypeMasks::FxBrickObjectType);
    %ontrack = 0;
    %twicespeed = %this.speed*2;
    %reversedspeed = %this.speed-%twicespeed;
    
    while(%searchObj= containerSearchNext())
    {
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideS") {
            %ontrack = 1;
            %newtrack = %searchObj;
            // trainturn command removed
            
            if(%this.curtrack == 0) {
                serverPlay3D(TrainAlignSound,%this.getPosition());
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideB") {
            %ontrack = 1;
            %newtrack = %searchObj;
            // trainturn command removed
            
            if(%this.curtrack == 0) {
                serverPlay3D(TrainAlignSound,%this.getPosition());
            }
            
            if(%this.speed < %this.enginemax*1.7) { // a train's max possible speed is 1.7x the max speed of it's engine.
                %this.speed = %this.speed*2;
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideSS") {
            %ontrack = 1;
            %newtrack = %searchObj;
            
            if(%this.curtrack == 0) {
                serverPlay3D(TrainAlignSound,%this.getPosition());
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideI") {
            %ontrack = 1;
            %newtrack = %searchObj;
            // trainturn command removed
            
            if(%this.curtrack == 0) {
                serverPlay3D(TrainAlignSound,%this.getPosition());
            }
            
            // hotfix
            %this.allowofftrack = 1;
            %this.schedule(3000,TrainLaunchDelay);
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideCL") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack) {
                if(%this.speed > 0) {
                    TrainTurn(%this, 45, %searchObj);
                } else {
                    TrainTurn(%this, -45, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideCR") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack && %this.turning == 0) {
                if(%this.speed > 0) {
                    TrainTurn(%this, -45, %searchObj);
                } else {
                    TrainTurn(%this, 45, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideTL") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack && %this.turning == 0) {
                if(%this.speed > 0) {
                    TrainTurn(%this, 90, %searchObj);
                } else {
                    TrainTurn(%this, -90, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideTR") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack && %this.turning == 0) {
                if(%this.speed > 0) {
                    TrainTurn(%this, -90, %searchObj);
                } else {
                    TrainTurn(%this, 90, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideWL") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack && %this.turning == 0) {
                if(%this.speed > 0) {
                    TrainTurn(%this, 22.5, %searchObj);
                } else {
                    TrainTurn(%this, -22.5, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideWR") {
            %ontrack = 1;
            %newtrack = %searchObj;
            %this.canalign = 1;
            %this.superalign = 0;
            
            if(%this.curtrack != %newtrack && %this.turning == 0) {
                if(%this.speed > 0) {
                    TrainTurn(%this, -22.5, %searchObj);
                } else {
                    TrainTurn(%this, 22.5, %searchObj);
                }
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideL") {
            if(%this.canlaunch == 1) {
                %this.canalign = 1;
                %this.superalign = 1;
                %ontrack = 0;
                %this.canlaunch = 0;
                %this.allowofftrack = 1;
                %this.schedule(1250,TrainLaunchDelay);
                %this.addVelocity("0 0 18");
                serverPlay3D(TrainLaunchSound,%this.getPosition());
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideTUL") {
            %ontrack = 1;
            %newtrack = %searchObj;
            
            if(%this.cantt == 1) {
                %this.cantt = 0;
                if(%this.enginestatus == 3 || %this.enginestatus == 0) { // engine must be off
                    if(%this.speed == 0) { // speed must be 0
                        TrainTurn(%this, -22.5, %searchObj);
                        serverPlay3D(TrainLaunchSound,%this.getPosition());
                    }
                }
                %this.schedule(500,TrainTTDelay);
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
        
        if(%searchObj.getDatablock().getName() $= "brickTrainGuideTUR") {
            %ontrack = 1;
            %newtrack = %searchObj;
            
            if(%this.cantt == 1) {
                %this.cantt = 0;
                if(%this.enginestatus == 3 || %this.enginestatus == 0) { // engine must be off
                    if(%this.speed == 0) { // speed must be 0
                        TrainTurn(%this, 22.5, %searchObj);
                        serverPlay3D(TrainLaunchSound,%this.getPosition());
                    }
                }
                %this.schedule(500,TrainTTDelay);
            }
            
            $InputTarget_["Self"]   = %searchObj;
            $InputTarget_["Train"] = %this;
            $InputTarget_["Minigame"] = getMiniGameFromObject(%searchObj);
            
            %searchObj.processInputEvent("OnTrainDetected", %targetObj.client);
            
            break;
        }
    }
    if(%ontrack == 0) { //if we're not, the train can't move at all.
        %this.curtrack = 0;
        if(%this.allowofftrack == 0) {
            %this.speed = 0;
        }
    } else { // if we are, however, we can do all this fun stuff:
        if(%newtrack != %this.curtrack && %this.canalign == 1) {
            %this.canalign = 0;
            SnapTrainToTrack(%this,%newtrack,%this.superalign); // try to align the train
            %this.schedule(4000,autoAlignDelay);
        }
        %this.curtrack = %newtrack;
        if(%this.enginestatus == 0) { // engine off - use normal train drag, no push
            %doubledrag = %this.drag*2;
            if(%this.speed >= %this.drag) {
                %this.speed=%this.speed-%this.drag;
            } else if(%this.speed <= %this.drag-%doubledrag) {
                %this.speed=%this.speed+%this.drag;
            } else {
                %this.speed = 0;
            }
        } else if(%this.enginestatus == 1) { // engine in forward mode - allow drag for speeds beyond max, increase push for speeds below
            %doubledrag = %this.drag*2;
            if(%this.speed >= %this.enginemax) {
                %this.speed=%this.speed-%doubledrag;
            } else {
                %this.speed=%this.speed+%this.enginepower;
            }
        } else if(%this.enginestatus == 2) { // engine in reverse mode - same as above but negatively
            %enginereverse = %this.enginemax*2;
            if(%this.speed <= %this.enginemax-%enginereverse) {
                %this.speed=%this.speed+%this.drag;
            } else {
                %this.speed=%this.speed-%this.enginepower;
            }
        } else if(%this.enginestatus == 3) { // engine brakes - use higher train drag, no push
            %quadrupledrag = %this.drag*4;
            %alotofdrag = %quadrupledrag*2;
            if(%this.speed >= %quadrupledrag) {
                %this.speed=%this.speed-%quadrupledrag;
            } else if(%this.speed <= %quadrupledrag-%alotofdrag) {
                %this.speed=%this.speed+%quadrupledrag;
            } else {
                %this.speed = 0;
            }
        }
    }
    
    SetTrainSpeed(%this,%this.speed);
    %this.schedule(100,TrainLoop);
}

function servercmdtrainmode(%cl,%m) {
    %v = %cl.player.getobjectmount();
    
    if(!isObject(%v)) {
        %cl.centerPrint("You must be in a train to use this command!",3);
        return;
    }
    
    if(%v.trainLocked == 1) {
        %cl.centerPrint("This train is locked!",3);
        return;
    }
    
    if(%v.isTrain == 1) {
        if(%m $= "off" || %m $= "neutral") {
            %v.enginestatus = 0;
            if(%v.playenginesound >= 1) {
                %v.playenginesound = -1;
            }
            %cl.centerPrint("<color:00ff00>Train set to <color:ffffff>NEUTRAL<color:00ff00> mode.",3);
        }
        else if(%m $= "forward" || %m $= "on") {
            if(%v.hasengine == 1) {
                %v.enginestatus = 1;
                if(%v.playenginesound <= 0) {
                    %v.playenginesound = 1;
                }
                %v.lastrotbrick = 0;
                %cl.centerPrint("<color:00ff00>Train set to <color:ffffff>FORWARD<color:00ff00> mode.",3);
            } else {
                %cl.centerPrint("The train you're in doesn't have an engine!",3);
            }
        }
        else if(%m $= "reverse" || %m $= "backward") {
            if(%v.hasengine == 1) {
                %v.enginestatus = 2;
                %v.lastrotbrick = 0;
                if(%v.playenginesound <= 0) {
                    %v.playenginesound = 1;
                }
                %cl.centerPrint("<color:00ff00>Train set to <color:ffffff>REVERSE<color:00ff00> mode.",3);
            } else {
                %cl.centerPrint("The train you're in doesn't have an engine!",3);
            }
        }
        else if(%m $= "brakes" || %m $= "brake" || %m $= "stop") {
            if(%v.hasbrakes == 1 && $Pref::Trains::Brakes == 1) {
                %cl.centerPrint("<color:00ff00>Train set to <color:ffffff>BRAKES<color:00ff00> mode.",3);
                %v.enginestatus = 3;
                if(%v.playenginesound >= 1) {
                    %v.playenginesound = 0;
                }
            } else {
                %cl.centerPrint("You can't brake in this train!",3);
            }
        } else {
            %cl.centerPrint("Invalid mode! (Use neutral/forward/reverse/brake)",3);
        }
    } else {
        %cl.centerPrint("You must be in a train to use this command!",3);
    }
}

function servercmdcentertrain(%cl) {
    %v = %cl.player.getobjectmount();
    
    if(!isObject(%v)) {
        %cl.centerPrint("You must be in a train to use this command!",3);
        return;
    }
    %v.lastrotbrick = 0;
    
    serverPlay3D(TrainAlignSound,%v.getPosition());
    
    %track = %v.curtrack;
    
    if(%v.curtrack.getDatablock().getName() $= "brickTrainGuideS") {
        SnapTrainToTrack(%v,%v.curtrack,1);
        %cl.centerPrint("<color:ffffff>Train aligned.",3);
    } else {
        %cl.centerPrint("You must place the train on a straight track guide to do this.",3);
    }
}

function servercmdtrainsoundhorn(%cl) {
    %v = %cl.player.getobjectmount();
    
    if(!isObject(%v)) {
        %cl.centerPrint("You must be in a train to sound the horn!",3);
        return;
    }
    
    if(%v.hornsound $= 0) {
        %cl.centerPrint("This train does not have a horn.",3);
    } else {
        serverPlay3D(%v.hornsound,%v.getposition());
    }
}

// TRADER'S AXIS/EULER STUFF - DO NOT TOUCH
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}